setmetatable(_ENV,{__index=function(s,k) local n=k:gsub("%.",","); local p=load(n);if p then _ENV[k]=p;_ENV[n]=p;return p end;return nil end})
clearlog()
print("Current Date: ",os.date(),", running with EEP ",EEPVer," and ",_VERSION)
TaskMemorizer = require("TaskMemorizer_BH2")
Schattenbahnhof = require("Schattenbahnhofssteuerung_BH2")

function EEPMain()
    Tasks:exec()
    return 1
end

function Test(task)
	local zs=EEPGetSignal(task.signalID)
	print("Zhlerstand: ",zs-1,"->",zs-2)
end

Tasks = TaskMemorizer:new{
	{name="Test",interval=10,offset=15,signalID=91,func=Test,isCounter=true},
	{name="Test2",interval=60,signalID=92,signalPosDone=1,func=function()
		 print("Ampel stand auf rot")
		 return true
	 end},
	{name="TestOhneFunktion",interval=10,signalID=39,func=Test3,isCounter=true},
	{name="TestOhneSignal",interval=10,func=Test},
	{name="SbfEinfahrtLinks",interval=10,signalID=143,func=function()
		if EEPGetSignal(89)==1 and sbf:einfahrt() then
			EEPSetSignal(89,2)
			EEPSetSignal(63,1)
			return true
		else return false end
	end,exclude={"SbfEinfahrtRechts"}},
	{name="SbfEinfahrtRechts",interval=10,signalID=144,func=function()
		if EEPGetSignal(89)==1 and sbf:einfahrt() then
			EEPSetSignal(89,2)
			EEPSetSignal(64,1)
			return true
		else return false end
	end,exclude={"SbfEinfahrtLinks"}},
	{name="SbfAusfahrtLinks",interval=10,signalID=146,func=function()
		if EEPGetSignal(90)==1 and sbf:ausfahrt() then
			EEPSetSignal(90,2)
			EEPSetSwitch(61,2)
			return true
		else return false end
	end,exclude={"SbfAusfahrtRechts"}},
	{name="SbfAusfahrtRechts",interval=10,signalID=145,func=function()
		if EEPGetSignal(90)==1 and sbf:ausfahrt() then
			EEPSetSignal(90,2)
			EEPSetSwitch(61,1)
			return true
		else return false end
	end,exclude={"SbfAusfahrtLinks"}},
	{name="SbfNebenbahnEinfahrt",interval=10,signalID=149,func=function()
		if sbfNebenbahn:einfahrt() then
			EEPSetSignal(40,1)
			return true
		else return false end
	end},
	{name="SbfNebenbahnAusfahrt",interval=10,signalID=148,func=function()
		return sbfNebenbahn:ausfahrt()
	end},
}
Tasks:print()

sbfNebenbahn = Schattenbahnhof:new{
	tracks={
		{signalID=81,switches={[76]=2}},
		{signalID=82,switches={[76]=1,[77]=2}},
		{signalID=83,switches={[76]=1,[77]=1,[78]=2}},
		{signalID=84,switches={[76]=1,[77]=1,[78]=1,[79]=2}},
	},
	debugLevel=2,
	name="NEBENSTRECKE",
}
sbfNebenbahn:print(true)

sbf = Schattenbahnhof:new{
	create={
		numTracks=9,
		signalIdStart=65,
		blockIdStart=142,
		blockIdIncrement=-1,
		switchIdStart=43,
		switchForLastTrack=true,
		flipFirstSwitch=true,
	},
	debugLevel=2,
	name="Hauptstrecke",
}
sbf:print(true)
